=== debian/changelog ===
libavif (0.8.2-2~mx19+1) mx; urgency=medium

  * Initial packaging for MX-19.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Sun, 11 Jul 2021 18:00:13 -0400

libavif (0.8.2-2~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Boyuan Yang <byang@debian.org>  Mon, 02 Nov 2020 09:39:06 -0500

libavif (0.8.2-2) unstable; urgency=medium

  * Source-only upload for testing migration.
  * debian/rules: Document that we are in lack of several codec
    support.
    + Enabled: dav1d
    + TODO: aom (need new version), libgav1, rav1e (need packaging)

 -- Boyuan Yang <byang@debian.org>  Sun, 18 Oct 2020 17:21:31 -0400

libavif (0.8.2-1) unstable; urgency=medium

  * New upstream release.
    + SONAME change: libavif6 -> libavif7.

 -- Boyuan Yang <byang@debian.org>  Sun, 18 Oct 2020 10:26:43 -0400

libavif (0.8.1-1) unstable; urgency=medium

  * Initial release.

 -- Boyuan Yang <byang@debian.org>  Sat, 15 Aug 2020 10:56:04 -0400
