=== debian/control ===
Source: libavif
Section: libs
Priority: optional
Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
# libaom-dev (>= 2~),
 libcjson-dev,
 libdav1d-dev,
 libgavl-dev,
 libgdk-pixbuf2.0-dev,
 libjpeg-dev,
 libpng-dev,
 pkg-config,
 zlib1g-dev,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://github.com/AOMediaCodec/libavif
Vcs-Git: https://salsa.debian.org/multimedia-team/libavif.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/libavif

Package: libavif-bin
Section: utils
Architecture: any
Depends:
 libavif7 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Library for handling .avif files (utilities)
 This library aims to be a friendly, portable C implementation of the AV1
 Image File Format as described in https://aomediacodec.github.io/av1-avif/.
 .
 This package provides several utilities provided by the library:
  - avifdec
  - avifenc

Package: libavif-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libavif7 (= ${binary:Version}),
 ${misc:Depends},
Description: Library for handling .avif files (development files)
 This library aims to be a friendly, portable C implementation of the AV1
 Image File Format as described in https://aomediacodec.github.io/av1-avif/.
 .
 This package provides the development files.

Package: libavif7
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Library for handling .avif files
 This library aims to be a friendly, portable C implementation of the AV1
 Image File Format as described in https://aomediacodec.github.io/av1-avif/.
 .
 This package provides the shared library files.

Package: libavif7-gdk-pixbuf
Architecture: any
Multi-Arch: same
Depends:
 libavif7 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Library for handling .avif files (GDK pixbuf plugin)
 This library aims to be a friendly, portable C implementation of the AV1
 Image File Format as described in https://aomediacodec.github.io/av1-avif/.
 .
 This package provides the GDK pixbuf plugin for the library.
