=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND =


%:
	dh $@

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_auto_configure:
	# TODO: -DAVIF_CODEC_AOM=ON
	# TODO: -DAVIF_CODEC_RAV1E=ON
	# TODO: -DAVIF_CODEC_LIBGAV1=ON
	dh_auto_configure -- \
	    -DAVIF_BUILD_APPS=ON \
	    -DAVIF_CODEC_DAV1D=ON \
	    -DAVIF_BUILD_GDK_PIXBUF=ON
