=== debian/changelog ===
libavif (0.8.4-2+deb11u2) bullseye-security; urgency=high

  * Non-maintainer upload by the LTS Security Team.
  * debian/gbp.conf: add file with minimal settings and debian/bullseye
    default.
  * debian/patches/:
      - CVE-2025-48174.patch: import patch from bookworm suggested by
        upstream and backport patch. (Closes: #1105885)
          + CVE-2025-48174: makeRoom in stream.c has an integer overflow and
            resultant buffer overflow in stream->offset+size.
      - CVE-2025-48175.patch: import patch from bookworm suggested by
        upstream and backport patch. (Closes: #1105883)
          + CVE-2025-48175: avifImageRGBToYUV in reformat.c has integer
            overflows in multiplications.
  * debian/salsa-ci.yml: add (E)LTS pipeline for bullseye.

 -- Carlos Henrique Lima Melara <charlesmelara@riseup.net>  Sun, 25 May 2025 21:37:01 -0300

libavif (0.8.4-2+deb11u1) bullseye; urgency=medium

  * debian/patches/c6acdf6b7c69c9d23917cf814a3b17ce639a7266.patch:
    Add upstream fix to correct libdir in libavif.pc pkgconfig file.
    (Closes: #994144)

 -- Boyuan Yang <byang@debian.org>  Sun, 12 Sep 2021 15:54:48 -0400

libavif (0.8.4-2) unstable; urgency=medium

  * Source-only upload. 
  * Mention that avifenc binary is not working for now.

 -- Boyuan Yang <byang@debian.org>  Mon, 07 Dec 2020 13:52:51 -0500

libavif (0.8.4-1) unstable; urgency=medium

  * New upstream release.
  * Bump SONAME to 9 following upstream.
  * Rename package libavif*-gdk-pixbuf to libavif-gdk-pixbuf since the
    package always provides the same file.
    + Breaks+Replaces relationship is updated accordingly.

 -- Boyuan Yang <byang@debian.org>  Sun, 29 Nov 2020 21:22:13 -0500

libavif (0.8.3-3) unstable; urgency=high

  * Let libavif8-gdk-pixbuf Breaks+Replaces libavif7-gdk-pixbuf.
    (Closes: #974593)

 -- Boyuan Yang <byang@debian.org>  Sat, 14 Nov 2020 09:22:15 -0500

libavif (0.8.3-2) unstable; urgency=medium

  * Source-only upload for testing migration. 

 -- Boyuan Yang <byang@debian.org>  Thu, 12 Nov 2020 09:57:46 -0500

libavif (0.8.3-1) unstable; urgency=medium

  * New upstream release.
  * Bump SONAME to 8 following upstream.
  * Also enable GAV1 encoding on armel architecture.

 -- Boyuan Yang <byang@debian.org>  Tue, 10 Nov 2020 10:08:36 -0500

libavif (0.8.2-4) unstable; urgency=medium

  * Only enable GAV1 encoding on certain architectures where build
    passes.

 -- Boyuan Yang <byang@debian.org>  Sun, 01 Nov 2020 20:59:50 -0500

libavif (0.8.2-3) unstable; urgency=medium

  * Enable GAV1 encoding. 

 -- Boyuan Yang <byang@debian.org>  Thu, 29 Oct 2020 10:35:02 -0400
