=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: libavif
 Section: libs
 Priority: optional
-Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Boyuan Yang <byang@debian.org>,
 Build-Depends:
@@ -11,13 +10,15 @@
 # libaom-dev (>= 2~),
  libcjson-dev,
  libdav1d-dev,
+# only enable when libgav1-dev exist, see rules file
+ libgav1-dev [amd64 arm64 armel armhf i386 mips64el ppc64el s390x hppa ppc64 riscv64 x32],
  libgavl-dev,
  libgdk-pixbuf2.0-dev,
  libjpeg-dev,
  libpng-dev,
  pkg-config,
  zlib1g-dev,
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://github.com/AOMediaCodec/libavif
 Vcs-Git: https://salsa.debian.org/multimedia-team/libavif.git
@@ -27,7 +28,7 @@
 Section: utils
 Architecture: any
 Depends:
- libavif7 (= ${binary:Version}),
+ libavif9 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Description: Library for handling .avif files (utilities)
@@ -37,13 +38,16 @@
  This package provides several utilities provided by the library:
   - avifdec
   - avifenc
+ .
+ Due to the temporary lack of support libraries, no decoder is available
+ for now. As a result, the avifenc binary won't work.
 
 Package: libavif-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
 Depends:
- libavif7 (= ${binary:Version}),
+ libavif9 (= ${binary:Version}),
  ${misc:Depends},
 Description: Library for handling .avif files (development files)
  This library aims to be a friendly, portable C implementation of the AV1
@@ -51,7 +55,7 @@
  .
  This package provides the development files.
 
-Package: libavif7
+Package: libavif9
 Architecture: any
 Multi-Arch: same
 Depends:
@@ -63,13 +67,19 @@
  .
  This package provides the shared library files.
 
-Package: libavif7-gdk-pixbuf
+Package: libavif-gdk-pixbuf
 Architecture: any
 Multi-Arch: same
 Depends:
- libavif7 (= ${binary:Version}),
+ libavif9 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
+Breaks:
+ libavif7-gdk-pixbuf,
+ libavif8-gdk-pixbuf,
+Replaces:
+ libavif7-gdk-pixbuf,
+ libavif8-gdk-pixbuf,
 Description: Library for handling .avif files (GDK pixbuf plugin)
  This library aims to be a friendly, portable C implementation of the AV1
  Image File Format as described in https://aomediacodec.github.io/av1-avif/.
