=== debian/changelog ===
libavif (0.9.3-3) unstable; urgency=medium

  * Enable libyuv support.
  * Enable libgav1 suppoort for mipsel.

 -- Boyuan Yang <byang@debian.org>  Mon, 14 Feb 2022 14:14:42 -0500

libavif (0.9.3-2) unstable; urgency=high

  * Upload to unstable with AOM support. (Closes: #976349)

 -- Boyuan Yang <byang@debian.org>  Tue, 02 Nov 2021 13:09:04 -0400

libavif (0.9.3-2~exp1) experimental; urgency=medium

  * Enable libaom support.

 -- Boyuan Yang <byang@debian.org>  Sun, 31 Oct 2021 16:06:31 -0400

libavif (0.9.3-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Sun, 31 Oct 2021 10:48:41 -0400

libavif (0.9.3-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Bump library SONAME to 13 following upstream.
  * debian/copyright: Refresh copyright information.

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Boyuan Yang <byang@debian.org>  Thu, 28 Oct 2021 17:01:27 -0400

libavif (0.9.2-2) unstable; urgency=medium

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Drop unused B-D on libgavl-dev
  * Add salsa-ci configuration

  [ Boyuan Yang ]
  * debian/salsa-ci.yml: Use default debian recipe.
  * debian/control: Bump Standards-Version to 4.6.0.

 -- Boyuan Yang <byang@debian.org>  Sat, 18 Sep 2021 13:33:13 -0400

libavif (0.9.2-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Tue, 17 Aug 2021 11:47:50 -0400

libavif (0.9.2-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Bump SONAME to 12 following upstream.

 -- Boyuan Yang <byang@debian.org>  Wed, 07 Jul 2021 17:05:58 -0400

libavif (0.9.1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Bump SONAME to 11 following upstream.

 -- Boyuan Yang <byang@debian.org>  Wed, 16 Jun 2021 15:37:26 -0400
