=== debian/control ===
--- 
+++ 
@@ -7,18 +7,18 @@
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
-# libaom-dev (>= 2~),
+ libaom-dev (>= 3~),
  libcjson-dev,
  libdav1d-dev,
 # only enable when libgav1-dev exist, see rules file
- libgav1-dev [amd64 arm64 armel armhf i386 mips64el ppc64el s390x hppa ppc64 riscv64 x32],
- libgavl-dev,
+ libgav1-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x hppa ppc64 riscv64 x32],
  libgdk-pixbuf2.0-dev,
  libjpeg-dev,
  libpng-dev,
+ libyuv-dev,
  pkg-config,
  zlib1g-dev,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://github.com/AOMediaCodec/libavif
 Vcs-Git: https://salsa.debian.org/multimedia-team/libavif.git
@@ -28,7 +28,7 @@
 Section: utils
 Architecture: any
 Depends:
- libavif9 (= ${binary:Version}),
+ libavif13 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Description: Library for handling .avif files (utilities)
@@ -47,7 +47,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libavif9 (= ${binary:Version}),
+ libavif13 (= ${binary:Version}),
  ${misc:Depends},
 Description: Library for handling .avif files (development files)
  This library aims to be a friendly, portable C implementation of the AV1
@@ -55,7 +55,7 @@
  .
  This package provides the development files.
 
-Package: libavif9
+Package: libavif13
 Architecture: any
 Multi-Arch: same
 Depends:
@@ -71,7 +71,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libavif9 (= ${binary:Version}),
+ libavif13 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Breaks:
