=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libavif-$1\.tar\.gz/ \
  https://github.com/AOMediaCodec/libavif/tags .*/v?(\d\S+)\.tar\.gz debian uupdate
